"""Init.

Revision ID: b41b37adf319
Revises: 
Create Date: 2022-10-26 17:11:47.612009

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = 'b41b37adf319'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('git_repo',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('url', sa.String(), nullable=False),
    sa.Column('archived', sa.Boolean(), nullable=False),
    sa.Column('project', sa.String(), nullable=False),
    sa.Column('username', sa.String(), nullable=True),
    sa.Column('password', sa.LargeBinary(), nullable=True),
    sa.Column('password_is_set', sa.Boolean(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('logo',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('name', sa.String(), nullable=False),
    sa.Column('extension', sa.String(), nullable=False),
    sa.Column('content', sa.LargeBinary(), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('repository_action',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=True),
    sa.Column('name', sa.String(), nullable=True),
    sa.Column('description', sa.String(), nullable=True),
    sa.Column('version', sa.String(), nullable=False),
    sa.Column('type', sa.Enum('python3', 'Undefined', name='repository_action_type'), nullable=False),
    sa.Column('kind', sa.Enum('Processor', 'Source', 'Publisher', 'Undefined', name='repository_action_kind'), nullable=False),
    sa.Column('status', sa.Enum('Scanning', 'Scanned', 'Scan Error', 'Build Pending', 'Building', 'Build Error', 'Built', name='action_status'), nullable=False),
    sa.Column('archive', sa.LargeBinary(), nullable=True),
    sa.Column('dynamic_outputs', sa.Boolean(), nullable=False),
    sa.Column('creation_date', sa.DateTime(), nullable=False),
    sa.Column('build_date', sa.DateTime(), nullable=True),
    sa.Column('source_id', sa.String(), nullable=True),
    sa.Column('owner_id', sa.String(), nullable=False),
    sa.Column('logo_id', sa.String(), nullable=True),
    sa.Column('build_error', sa.String(), nullable=True),
    sa.Column('categories', postgresql.ARRAY(sa.String()), nullable=True),
    sa.Column('project', sa.String(), nullable=False),
    sa.Column('sha', sa.String(), nullable=False),
    sa.Column('metadata_path', sa.String(), nullable=False),
    sa.Column('scan_errors', postgresql.ARRAY(sa.String()), nullable=True),
    sa.Column('addons', sa.JSON(), nullable=True),
    sa.ForeignKeyConstraint(['logo_id'], ['logo.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['source_id'], ['git_repo.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('scan_result',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('scan_date', sa.DateTime(), nullable=False),
    sa.Column('project', sa.String(), nullable=False),
    sa.Column('source_id', sa.String(), nullable=False),
    sa.Column('sha', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['source_id'], ['git_repo.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('action_io',
    sa.Column('id', sa.String(), nullable=False),
    sa.Column('technical_name', sa.String(), nullable=False),
    sa.Column('display_name', sa.String(), nullable=False),
    sa.Column('help', sa.String(), nullable=True),
    sa.Column('type', sa.Enum('bytes', 'string', 'integer', 'float', 'boolean', 'file', 'directory', 'longstring', 'password', 'enum', 'table', name='action_io_type'), nullable=False),
    sa.Column('kind', sa.Enum('input', 'output', name='action_io_kind'), nullable=False),
    sa.Column('enum_values', postgresql.ARRAY(sa.String()), nullable=True),
    sa.Column('action_id', sa.String(), nullable=True),
    sa.Column('default_value', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['action_id'], ['repository_action.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('scan_result_action_association',
    sa.Column('scan_result_id', sa.String(), nullable=True),
    sa.Column('action_id', sa.String(), nullable=True),
    sa.ForeignKeyConstraint(['action_id'], ['repository_action.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['scan_result_id'], ['scan_result.id'], )
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('scan_result_action_association')
    op.drop_table('action_io')
    op.drop_table('scan_result')
    op.drop_table('repository_action')
    op.drop_table('logo')
    op.drop_table('git_repo')
    # ### end Alembic commands ###
